/***********************************************************************/
/*	grshlt.c                                                      */
/***********************************************************************/

/* function to draw a line between two points and shade left to indicated column */
grshlt(c1,r1,c2,r2,c3,lc,sc)
int c1; /* column coordinate of first point */
int r1; /* row coordinate of first point */
int c2; /* column coordinate of second point */
int r2; /* row coordinate of second point */
int c3; /* column to shade to */
int lc; /* color of line */
int sc; /* color of shade */
{
int dr; /* delta r */
int dc; /* delta c */
int rem; /* remainder of slope */
int slope; /* slope */
int r; /* row coordinate to write out */
int c; /* column coordinate to write out */
int i; /* counter of # of points written out */
int j; /* temp counter of incrementing remainder */
int ir; /* increment value of row */
int ic; /* increment value of column */
int mode; /* current mode */
int cols; /* current # of columns */
int page; /* current page */
/* do checks */
getscmod(&mode,&cols,&page);
if(mode < 3) return(-1);
cols = cols * 8;
if((r1 < 0)||(r1 > 199)) return(-2);
if((c1 < 0)||(c1 > cols - 1)) return(-3);
if((r2 < 0)||(r2 > 199)) return(-4);
if((c2 < 0)||(c2 > cols - 1)) return(-5);
if((lc < 1)||(lc > 3)) return(-6);
if((sc < 1)||(sc > 3)) return(-7);
if((c3 < 0)||(c3 > cols - 1)) return(-8);
/* get delta r and c */
dr = ((r1-r2)<0?-(r1-r2):(r1-r2));
dc = ((c1-c2)<0?-(c1-c2):(c1-c2));
/* check that we aren't writing out just one point */
if((dr == 0)&&(dc == 0))
  {
  dot(c1,r1,lc);
  if((c1 - 1) > c3) grline(c1 - 1,r1,c3,r1,sc);
  return(1);
  }
/* which way does the slope go ? */
if(dr > dc) goto vertical;
r = r1;
c = c1;
if(c1 > c2) ic = -1;
  else ic = 1;
if(r1 > r2) ir = -1;
  else ir = 1;
/* get slopes remainder */
rem = dr % dc;
/* write out start point */
dot(c1,r1,lc);
if((c1 - 1) > c3) grline(c1 - 1,r1,c3,r1,sc);
/* check for diagonal */
if(dc == dr)
  {
  j = 1;
  dc = 0;
  }
  else j = dc / 2;
/* start loop for line slopes > 1 */
for(i = 1; ; ++i)
  {
  /* are we done ? */
  if((r == r2)&&(c == c2)) return(i);
  j = j + rem;
  if(j > dc)
    {
    r = r + ir;
    j = j - dc;
    }
  c = c + ic;
  dot(c,r,lc);
  if((c - 1) > c3) grline(c - 1,r,c3,r,sc);
  }
vertical:
r = r1;
c = c1;
if(c1 > c2) ic = -1;
  else ic = 1;
if(r1 > r2) ir = -1;
  else ir = 1;
/* get slopes remainder */
rem = dc % dr;
/* write out start point */
dot(c1,r1,lc);
if((c1 - 1) > c3) grline(c1 - 1,r1,c3,r1,sc);
j = dr / 2;
/* start loop for line slopes < or = 1 */
for(i = 1; ; ++i)
  {
  /* are we done ? */
  if((r == r2)&&(c == c2)) return(i);
  j = j + rem;
  if(j > dr)
    {
    c = c + ic;
    j = j - dr;
    }
  r = r + ir;
  dot(c,r,lc);
  if((c - 1) > c3) grline(c - 1,r,c3,r,sc);
  }
}
