/***********************************************************************/
/*	monsfrom.c                                                    */
/***********************************************************************/

/* function to return a new date from a date & # of months to be added */
monthsfrom(out,year,month,day,nmonths,convert)
char *out; /* output (target) pointer */
int year; /* year passed */
int month; /* month passed */
int day; /* day passed */
int nmonths; /* # of months to be added */
int convert; /* conversion code                            */
             /* 50 - yymm                                  */
             /* 51 - yyyymm                                */
             /* 52 - mmyy                                  */
             /* 53 - mmyyyy                                */
             /* 54 - mm..m yy                              */
             /* 55 - mm..m yyyy                            */
             /* 56 - yy mm..m                              */
             /* 57 - yyyy mm..m                            */
             /* 58 - mmm yy                                */
             /* 59 - mmm yyyy                              */
             /* 60 to 69 have "/" between months and years */
             /* 70 to 79 have "-" between months and years */
             /* 80 - mm                                    */
             /* 81 - mmm                                   */
             /* 82 - mm..m                                 */
             /* 83 - yy                                    */
             /* 84 - yyyy                                  */
{
int y1; /* century part of the year */
int y2; /* remaining part of the year */
int m1; /* month after advance */
int k; /* increment variable */
int d; /* temp counter */
/* break up year */
if(year > 100)
  {
  y1 = year / 100;
  y2 = year % 100;
  }
  else
  {
  y1 = 19;
  y2 = year;
  }
/* month range check */
if((month < 1)||(month > 12)) return(-3);
m1 = month;
if(nmonths == 0) goto end;
if(nmonths > 0) k = 1;
  else k = -1;
/* start advancing thru */
for(d = k; d != (nmonths + k); d = d + k)
  {
  m1 = m1 + k;
  if((m1 == 13)||(m1 == 0))
    {
    m1 = m1 - (12 * k);
    y2 = y2 + k;
    if((y2 == 100) || (y2 == -1))
      {
      y2 = y2 - (100 * k);
      y1 = y1 + k;
      }
    }
  continue;
  }
end:
k = cdate(out,y1,y2,m1,day,convert);
if(k < 0) return(k);
return(0);
}
