/***********************************************************************/
/*	yrsfrom.c                                                     */
/***********************************************************************/

/* function to return a new date from a date & # of years to be added */
yearsfrom(out,year,month,day,nyears,convert)
char *out; /* output (target) string */
int year; /* year passed */
int month; /* month passed */
int day; /* day passed */
int nyears; /* # of years to be added */
int convert; /* conversion code */
             /* see strdate & monthsfrom */
{
int y1; /* century part of the year */
int y2; /* remaining part of the year */
int k; /* increment variable */
int d; /* temp counter */
/* month range check */
if((convert != 83)&&(convert != 84))
  {
  if((month < 1)||(month > 12)) return(-3);
  }
/* break up year */
if(year > 100)
  {
  y1 = year / 100;
  y2 = year % 100;
  }
  else
  {
  y1 = 19;
  y2 = year;
  }
if(nyears == 0) goto end;
if(nyears > 0) k = 1;
  else k = -1;
/* start advancing thru */
for(d = k; d != (nyears + k); d = d + k)
  {
  y2 = y2 + k;
  if((y2 == 100) || (y2 == -1))
    {
    y2 = y2 - (100 * k);
    y1 = y1 + k;
    }
  continue;
  }
end:
k = cdate(out,y1,y2,month,day,convert);
if(k < 0) return(k);
return(0);
}
